%define version 2.3.1
%define release %mkrel 6
%define wwwdir /var/www/html
	
Name:		oar
Version:	%{version}
Release:	%{release}
Summary:	OAR Batch Scheduler
License:	GPL
Group:		System/Servers
Url:		http://oar.imag.fr
Source0:	https://gforge.inria.fr/frs/download.php/5170/%{name}-%{version}.tar.gz
Source1:	oar-server.init
Source2:	oar-node.init
Source3:	oar-server.sysconfig
Source4:	oar-node.sysconfig
Patch1: 	oar-2.3.1-fix-install.patch
Patch2: 	oar-2.3.1-fix-documentation-build.patch
Patch3: 	oar-2.3.1-monika-no-private-library.patch
Patch4: 	oar-2.3.1-monika-fhs.patch
Patch5: 	oar-2.3.1-fix-pod.patch
Patch6: 	oar-2.3.1-fix-database-creation.patch
BuildRequires:	python-docutils
BuildRoot:	%{_tmppath}/%{name}-%{version}

%description 
This is OAR Batch Scheduler

%package common
Summary:	OAR batch scheduler common package
Group:		System/Servers
BuildArch: 	noarch
Requires:	openssh-clients
Requires:	openssh-server

%description common
This package installs the server part or the OAR batch scheduler

%package server
Summary:	OAR batch scheduler server package
Group:		System/Servers
Requires:	oar-common = %version-%release
Requires:	fping
Requires:	nmap

%description server
This package installs the server part or the OAR batch scheduler

%package admin
Summary:	OAR batch scheduler administration tools package
Group:		System/Servers
Requires:	oar-common = %version-%release
requires:   ruby-dbi

%description admin
This package installs some useful tools to help the administrator of a oar
server (resources manipulation, admission rules edition, ...)

%package user
Summary:	OAR batch scheduler node package
Group:		System/Servers
Requires:	oar-common = %version-%release
Requires:	perl(YAML)
BuildArch: 	noarch

%description user
This package install the submition and query part or the OAR batch scheduler

%package node
Summary:	OAR batch scheduler node package
Group:		System/Servers
Requires:	oar-common = %version-%release

%description node
This package installs the execution node part or the OAR batch scheduler

%package web-status
Summary:	OAR batch scheduler web-status package
Group:		System/Servers
Requires:	oar-common = %version-%release
Requires:	oar-user = %version-%release
requires:   apache
requires:   ruby-gd
requires:   ruby-dbi

%description web-status
This package installs the OAR batch scheduler Gantt reservation diagram CGI:
DrawGantt and the instant cluster state visualization CGI: Monika

%package doc
Summary:	OAR batch scheduler documentation package
Group:		Books/Computer books

%description doc
This package install some documentation for OAR batch scheduler

%prep
%setup -q
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1

%build
cd Docs/documentation
%make

%install
%__rm -rf %{buildroot}

%__make common configuration libs doc-install server dbinit node user draw-gantt monika www-conf tools \
    OARUSER=oar \
    PREFIX=%{_prefix} \
    OARCONFDIR=%{_sysconfdir}/%{name} \
    OARDIR=%{_datadir}/%{name} \
    DOCDIR=%{_docdir}/%{name} \
    MANDIR=%{_mandir} \
    WWWDIR=/var/www/%{name} \
    CGIDIR=/var/www/%{name} \
    DESTDIR=%{buildroot}

perl -pi -e 's|/usr/lib/oar|%{_datadir}/%{name}|'  \
    %{buildroot}%{_docdir}/%{name}/html/OAR-DOCUMENTATION-ADMIN.html \
    %{buildroot}%{_datadir}/%{name}/oarnodesetting_ssh \
    %{buildroot}%{_sysconfdir}/%{name}/oar.conf

perl -pi \
    -e 's|^#OAR_RUNTIME_DIRECTORY=.*|OAR_RUNTIME_DIRECTORY="/var/lib/oar"|;' \
    -e 's|^#OPENSSH_CMD=.*|OPENSSH_CMD="/usr/bin/ssh -p 6667"|;' \
     %{buildroot}%{_sysconfdir}/%{name}/oar.conf

# apache configuration
install -d -m 755 %{buildroot}%{_webappconfdir}
cat > %{buildroot}%{_webappconfdir}/%{name}.conf <<EOF
Alias /monika %{_var}/www/%{name}/monika
Alias /drawgantt %{_var}/www/%{name}/drawgantt

<Directory %{_var}/www/%{name}/monika>
    Options ExecCGI
    DirectoryIndex monika.cgi
    Allow from all
</Directory>

<Directory %{_var}/www/%{name}/drawgantt>
    Options ExecCGI FollowSymlinks
    DirectoryIndex drawgantt.cgi
    Allow from all
</Directory>
EOF

rm -f %{buildroot}%{_sysconfdir}/%{name}/apache.conf
install -d -m 755 %{buildroot}%{_var}/www/%{name}/drawgantt
install -d -m 755 %{buildroot}%{_var}/lib/%{name}/drawgantt
install -d -m 755 %{buildroot}%{_var}/www/%{name}/monika
pushd %{buildroot}%{_var}/www/%{name}
mv drawgantt.cgi drawgantt
mv monika.cgi monika
mv userInfos.cgi monika
mv monika.css monika
pushd drawgantt
rmdir cache
ln -sf ../../../lib/%{name}/drawgantt cache
popd
popd

perl -pi -e 's|^web_root.*|web_root: "%{_var}/www/%{name}"|' \
    %{buildroot}%{_sysconfdir}/%{name}/drawgantt.conf
perl -pi -e 's|^css_path.*|css_path = /monika/monika.css|' \
    %{buildroot}%{_sysconfdir}/%{name}/monika.conf

chmod 640  %{buildroot}%{_sysconfdir}/%{name}/monika.conf
chmod 640  %{buildroot}%{_sysconfdir}/%{name}/drawgantt.conf

install -d -m 755 %{buildroot}%{_sysconfdir}/logrotate.d
cat > %{buildroot}%{_sysconfdir}/logrotate.d/%{name}.conf <<EOF
/var/log/oar.log {
    daily
    missingok
    notifempty
}
EOF

install -d -m 755 %{buildroot}%{_sysconfdir}/cron.d
cat > %{buildroot}%{_sysconfdir}/cron.d/%{name}-server <<EOF
0 * * * * root /usr/share/oar/oaraccounting
}
EOF
cat > %{buildroot}%{_sysconfdir}/cron.d/%{name}-node <<EOF
0 * * * * root /usr/share/oar/oarnodecheckrun
}
EOF

install -d -m 755 %{buildroot}%{_initrddir}
install -m 755 %{SOURCE1} %{buildroot}%{_initrddir}/oar-server
install -m 755 %{SOURCE2} %{buildroot}%{_initrddir}/oar-node
install -d -m 755 %{buildroot}%{_sysconfdir}/sysconfig
install -m 755 %{SOURCE3} %{buildroot}%{_sysconfdir}/sysconfig/oar-server
install -m 755 %{SOURCE4} %{buildroot}%{_sysconfdir}/sysconfig/oar-node

cat > %{buildroot}%{_sbindir}/oar-server <<'EOF'
#!/bin/sh

%{_sbindir}/Almighty $* &
jobs -p  > /var/run/`basename $0`.pid
EOF
chmod +x %{buildroot}%{_sbindir}/oar-server

install -d -m 755 %{buildroot}%{_var}/lib/oar
install -d -m 755 %{buildroot}%{_var}/lib/oar/.ssh
install -d -m 755 %{buildroot}%{_var}/lib/oar/checklogs
cat > %{buildroot}%{_var}/lib/oar/.ssh/config <<EOF
	Host *
	ForwardX11 no
	StrictHostKeyChecking no
EOF

cat > README.urpmi <<EOF
Post-installation instructions

You have to create a database for the server, using either:
- postgresql: install perl-DBD-pg, and run oar_psql_db_init
- mysql: install perl-DBD-mysql, and run oar_mysql_db_init
EOF

%clean
rm -rf %{buildroot}

%pre common
%_pre_useradd %{name} %{_var}/lib/%{name} %{_datadir}/%{name}/oarsh_shell
%create_ghostfile /var/log/oar.log oar oar 644

%postun common
%_postun_userdel %{name}

%post server
if [ $1 = 1 ]; then
    cd %{_var}/lib/%{name}/.ssh
    if [ ! -e id_dsa.pub -o ! -e id_dsa.pub -o ! -e authorized_keys ]; then
        ssh-keygen -t dsa -q -f id_dsa -N ''
        cp id_dsa.pub authorized_keys
        chown oar.oar id_dsa id_dsa.pub authorized_keys
    fi
    cd -
fi
%_post_service oar-server

%preun server
%_preun_service oar-server

%post node
# create oar sshd keys
if [ ! -f %{_sysconfdir}/%{name}/oar_ssh_host_rsa_key ]; then
    rm -f %{_sysconfdir}/%{name}/oar_ssh_host_rsa_key.pub
    cp %{_sysconfdir}/ssh/ssh_host_rsa_key \
        %{_sysconfdir}/%{name}/oar_ssh_host_rsa_key
    cp %{_sysconfdir}/ssh/ssh_host_rsa_key.pub \
        %{_sysconfdir}/%{name}/oar_ssh_host_rsa_key.pub
fi

if [ ! -f %{_sysconfdir}/%{name}/oar_ssh_host_dsa_key ]; then
    rm -f %{_sysconfdir}/%{name}/oar_ssh_host_dsa_key.pub
    cp %{_sysconfdir}/ssh/ssh_host_dsa_key \
        %{_sysconfdir}/%{name}/oar_ssh_host_dsa_key
    cp %{_sysconfdir}/ssh/ssh_host_dsa_key.pub \
        %{_sysconfdir}/%{name}/oar_ssh_host_dsa_key.pub
fi

%_post_service oar-node

%preun node
%_preun_service oar-node

%post web-status
%_post_webapp

%preun web-status
%_postun_webapp

%files common
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/%{name}/oar.conf
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}.conf
%attr(6750,oar,oar) %{_sbindir}/oarnodesetting
%{_bindir}/oarcp
%{_bindir}/oarsh
%dir %{_datadir}/%{name}
%dir %{_datadir}/%{name}/oardodo
%{_datadir}/%{name}/oar_Judas.pm
%{_datadir}/%{name}/oar_Tools.pm
%{_datadir}/%{name}/oar_conflib.pm
%{_datadir}/%{name}/oar_iolib.pm
%{_datadir}/%{name}/oar_resource_tree.pm
%attr(6750,root,oar) %{_datadir}/%{name}/oardodo/oardodo
%{_datadir}/%{name}/oarnodesetting
%{_datadir}/%{name}/oarnodesetting_ssh
%{_datadir}/%{name}/oarsh
%attr(6755,oar,oar) %{_datadir}/%{name}/oarsh_oardo
%{_datadir}/%{name}/oarversion.pm
%{_datadir}/%{name}/sentinelle.pl
%{_datadir}/%{name}/oarsh_shell
%{_mandir}/man1/oarcp.1*
%{_mandir}/man1/oarsh.1*
%{_mandir}/man1/oarnodesetting.1*
%dir %attr(-,oar,oar) %{_var}/lib/oar

%files server
%doc README README.urpmi
%defattr(-,root,root)
%config(noreplace) %{_initrddir}/oar-server
%config(noreplace) %{_sysconfdir}/sysconfig/oar-server
%config(noreplace) %{_sysconfdir}/cron.d/oar-server
%config(noreplace) %{_sysconfdir}/%{name}/job_resource_manager.pl
%config(noreplace) %{_sysconfdir}/%{name}/oarmonitor_sensor.pl
%config(noreplace) %{_sysconfdir}/%{name}/server_epilogue
%config(noreplace) %{_sysconfdir}/%{name}/server_prologue
%config(noreplace) %{_sysconfdir}/%{name}/suspend_resume_manager.pl
%attr(-,oar,oar) %dir %{_var}/lib/%{name}/.ssh
%attr(-,oar,oar) %config(noreplace) %{_var}/lib/%{name}/.ssh/config
%attr(6750,oar,oar) %{_sbindir}/Almighty
%{_sbindir}/oar-server
%attr(6750,oar,oar) %{_sbindir}/oar_mysql_db_init
%{_sbindir}/oar_psql_db_init
%attr(6750,oar,oar) %{_sbindir}/oaraccounting
%attr(6750,oar,oar) %{_sbindir}/oarmonitor
%attr(6750,oar,oar) %{_sbindir}/oarnotify
%attr(6750,oar,oar) %{_sbindir}/oarproperty
%attr(6750,oar,oar) %{_sbindir}/oarremoveresource
%{_mandir}/man1/Almighty.1*
%{_mandir}/man1/oar_mysql_db_init.1*
%{_mandir}/man1/oaraccounting.1*
%{_mandir}/man1/oarmonitor.1*
%{_mandir}/man1/oarnotify.1*
%{_mandir}/man1/oarproperty.1*
%{_mandir}/man1/oarremoveresource.1*
%{_datadir}/%{name}/Almighty
%{_datadir}/%{name}/Gantt_hole_storage.pm
%{_datadir}/%{name}/Leon
%{_datadir}/%{name}/NodeChangeState
%{_datadir}/%{name}/bipbip
%{_datadir}/%{name}/default_data.sql
%{_datadir}/%{name}/finaud
%{_datadir}/%{name}/mysql_default_admission_rules.sql
%{_datadir}/%{name}/mysql_structure.sql
%{_datadir}/%{name}/oar_meta_sched
%{_datadir}/%{name}/oar_mysql_db_init
%{_datadir}/%{name}/oar_psql_db_init
%{_datadir}/%{name}/oar_scheduler.pm
%{_datadir}/%{name}/oaraccounting
%{_datadir}/%{name}/oarexec
%{_datadir}/%{name}/oarmonitor
%{_datadir}/%{name}/oarnotify
%{_datadir}/%{name}/oarproperty
%{_datadir}/%{name}/oarremoveresource
%{_datadir}/%{name}/pg_default_admission_rules.sql
%{_datadir}/%{name}/pg_structure.sql
%{_datadir}/%{name}/ping_checker.pm
%{_datadir}/%{name}/runner
%{_datadir}/%{name}/sarko
%{_datadir}/%{name}/schedulers/oar_sched_gantt_with_timesharing
%{_datadir}/%{name}/schedulers/oar_sched_gantt_with_timesharing_and_fairsharing

%files user
%defattr(-,root,root)
%{_datadir}/%{name}/oarnodes
%{_datadir}/%{name}/oardel
%{_datadir}/%{name}/oarstat
%{_datadir}/%{name}/oarsub
%{_datadir}/%{name}/oarhold
%{_datadir}/%{name}/oarresume
%attr(6755,oar,oar) %{_bindir}/oardel
%attr(6755,oar,oar) %{_bindir}/oarhold
%attr(6755,oar,oar) %{_bindir}/oarnodes
%attr(6755,oar,oar) %{_bindir}/oarresume
%attr(6755,oar,oar) %{_bindir}/oarstat
%attr(6755,oar,oar) %{_bindir}/oarsub
%{_bindir}/oarmonitor_graph_gen
%{_mandir}/man1/oardel.1*
%{_mandir}/man1/oarhold.1*
%{_mandir}/man1/oarmonitor_graph_gen.1*
%{_mandir}/man1/oarnodes.*
%{_mandir}/man1/oarresume.*
%{_mandir}/man1/oarstat.*
%{_mandir}/man1/oarsub.*

%files node
%defattr(-,root,root)
%config(noreplace) %{_initrddir}/oar-node
%config(noreplace) %{_sysconfdir}/sysconfig/oar-node
%config(noreplace) %{_sysconfdir}/cron.d/oar-node
%config(noreplace) %{_sysconfdir}/oar/check.d
%config(noreplace) %{_sysconfdir}/oar/epilogue
%config(noreplace) %{_sysconfdir}/oar/prologue
%config(noreplace) %{_sysconfdir}/oar/sshd_config
%{_bindir}/oarnodechecklist
%{_bindir}/oarnodecheckquery
%{_datadir}/%{name}/detect_resources
%{_datadir}/%{name}/oarnodecheckrun
%dir %attr(-,oar,oar) %{_var}/lib/oar/checklogs

%files web-status
%defattr(-,root,root)
%config(noreplace) %{_webappconfdir}/%{name}.conf
%attr(-,root,apache) %config(noreplace) %{_sysconfdir}/oar/drawgantt.conf
%attr(-,root,apache) %config(noreplace) %{_sysconfdir}/oar/monika.conf
%{_datadir}/%{name}/monika
%{_var}/www/%{name}
%attr(-,apache,apache) %{_var}/lib/%{name}/drawgantt

%files doc
%defattr(-,root,root)
%{_docdir}/%{name}

%files admin
%defattr(-,root,root)
%{_datadir}/%{name}/oar_modules.rb
%{_datadir}/%{name}/oaradmin.rb
%{_datadir}/%{name}/oaradmin_modules.rb
%attr(6750,oar,oar) %{_sbindir}/oaradmin
%{_mandir}/man1/oaradmin.1*


%changelog
* Fri Sep 05 2008 Guillaume Rousse <guillomovitch@mandriva.org> 2.3.1-6mdv2009.0
+ Revision: 281226
- fix executables perms and ownership
- fix drawgantt apache configuration
- fix man pages syntax
- fix mysql database creation on utf-8 systems

* Thu Sep 04 2008 Guillaume Rousse <guillomovitch@mandriva.org> 2.3.1-4mdv2009.0
+ Revision: 280458
- better installation patch
- add dependencies on ruby-dbi, now it is available

* Thu Aug 14 2008 Guillaume Rousse <guillomovitch@mandriva.org> 2.3.1-3mdv2009.0
+ Revision: 272094
- various fixes for web package

* Thu Aug 14 2008 Guillaume Rousse <guillomovitch@mandriva.org> 2.3.1-2mdv2009.0
+ Revision: 272026
- add ruby-gd dependency for web package
- drop mysql-specific dependencies, as postgresl is also supported, and update post-install instructions
- fix main directory location in various places
- fix server wrapper perms
- fix occurence of buildroot in installed files
- fix webapps configuration files

* Wed Aug 13 2008 Guillaume Rousse <guillomovitch@mandriva.org> 2.3.1-1mdv2009.0
+ Revision: 271476
- new version
  large spec cleanup, based on upstream one
- use README.urpmi instead of stdout to display post-installations instructions
- use standard rpm-helper macros for servicce
- don't requires a local mysql server
- spec cleanup: drop implicit dependencies

* Wed Jul 30 2008 Thierry Vignaud <tvignaud@mandriva.com> 1.6.2-14mdv2009.0
+ Revision: 254156
- rebuild

  + Pixel <pixel@mandriva.com>
    - adapt to %%_localstatedir now being /var instead of /var/lib (#22312)

* Fri Dec 21 2007 Olivier Blin <oblin@mandriva.com> 1.6.2-12mdv2008.1
+ Revision: 136633
- restore BuildRoot

  + Thierry Vignaud <tvignaud@mandriva.com>
    - kill re-definition of %%buildroot on Pixel's request
    - fix man pages


* Wed Mar 07 2007 Nicolas Lécureuil <neoclust@mandriva.org> 1.6.2-12mdv2007.1
+ Revision: 134808
- Fix Group

* Fri Mar 02 2007 Antoine Ginies <aginies@mandriva.com> 1.6.2-11mdv2007.1
+ Revision: 131349
- remove the -o user -g group in Makefile
- Import oar

* Wed Nov 08 2006 Antoine Ginies <aginies@mandriva.com> 1.6.2-11mdviggi
- Add nmap requires

* Fri Nov 03 2006 Antoine Ginies <aginies@mandriva.com> 1.6.2-10mdviggi
- Change DrawOARGantt cache directory

* Fri Oct 27 2006 iggi <iggi@guibux.mandrakesoft.com> 1.6.2-9mdviggi
- add an fping require

* Tue Oct 24 2006 iggi <iggi@guibux.mandrakesoft.com> 1.6.2-8mdviggi
- fix again cache directory

* Wed Oct 18 2006 iggi <iggi@guibux.mandrakesoft.com> 1.6.2-7mdviggi
- fix cache directory of DrawOARGantt
- move deploy_node.sh in /usr/sbin
- adjust oar-server output

* Sun Oct 15 2006 iggi <iggi@guibux.mandrakesoft.com> 1.6.2-6mdviggi
- laucnh Almighty with oar-server script

* Sun Oct 15 2006 iggi <iggi@guibux.mandrakesoft.com> 1.6.2-5mdviggi
- fix perm on authorized_keys

* Sat Oct 14 2006 iggi <iggi@guibux.mandrakesoft.com> 1.6.2-4mdviggi
- fix initscript (no simple way to use daemon)

* Sat Oct 14 2006 iggi <iggi@guibux.mandrakesoft.com> 1.6.2-3mdviggi
- fix oarstatcmd in DrawGantt conf
- fix apache sudoers conf
- fix all user OARcmd access
- fix OARUSER in sudowrapper.sh script

* Fri Oct 13 2006 iggi <iggi@guibux.mandrakesoft.com> 1.6.2-2mdviggi
- use oar.sh in /etc/profile.d 
- fix problem in sudoers OARDIR env

* Tue Oct 10 2006 iggi <iggi@guibux.mandrakesoft.com> 1.6.2-1mdviggi
- release rc2

* Thu Mar 02 2006 Antoine Ginies <aginies@mandriva.com> 1.6.1-1mdk
- based on Pierre Neyron spec
- fix requires
- fix oar-server service
- fix use /usr/lib/perl5/vendor_perl/5.8.8 to fix various pb with @INC (oar doesn't use MakeMaker...)
- move oar.conf to common
- fix DrawGant cache directory
- fix DrawGantt path
- fix defattr
- fix various chmod
- fix OARDIR in sudowrapper.sh script

* Wed May 11 2005 Pierre Lombard <pl@icatis.com> 1.6-1
- New upstream version.

* Fri Feb 04 2005 Sebastien Georget <sebastien.georget@sophia.inria.fr> 1.4-1
- Update dependencies, change Source0 and %%setup to use default oar distribution

* Thu Jul 01 2004 Pierre Neyron <pierre.neyron@imag.fr> 1.0-1
- First RPM package

